﻿package  {
	
	import flash.display.MovieClip;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Point;
	
	public class Twilight extends MovieClip {
//----------------------------TWILIGHT VARIABLES------------------------------
		private var left:Boolean, right:Boolean, up:Boolean, down:Boolean, jumping:Boolean, bubbled:Boolean;
		private var Xspeed:Number, Yspeed:Number, Acceleration:Number, Friction:Number, JumpSpeed:Number, Gravity:Number, MaxXspeed:Number, MaxYspeed:Number;
		private var LeftPoint:Point, RightPoint:Point, UpPoint:Point, DownPoint:Point;
		private var Main:MovieClip, Level:MovieClip, bubble:MovieClip;
		
		public function Twilight(Main:MovieClip, Level:MovieClip, bubble:MovieClip, X:Number = 230, Y:Number = 370) {
			this.x = X;
			this.y = Y;
			bubble.x = this.x;
			bubble.y = this.y - (this.height / 2);
			this.jumping = false;
			this.bubbled = false;
			this.Main = Main;
			this.Level = Level;
			this.bubble = bubble;
			this.Xspeed = 0;
			this.Yspeed = 0;
			this.Acceleration = 0.75;
			this.Friction = 0.80;
			this.JumpSpeed = 15;
			this.Gravity = 0.8;
			this.MaxXspeed = 10;
			this.MaxYspeed = 15;
			this.LeftPoint = new Point();
			this.RightPoint = new Point();
			this.UpPoint = new Point();
			this.DownPoint = new Point();
			
			this.addEventListener(Event.ADDED_TO_STAGE, addedToStage);
		}
		
		private function addedToStage(event:Event){
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mouseDownHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, mouseUpHandler);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			stage.addEventListener(Event.ENTER_FRAME, onFrameHandler);
		}
		
		private function removeHandlers(){
			stage.removeEventListener(MouseEvent.MOUSE_DOWN, mouseDownHandler);
			stage.removeEventListener(MouseEvent.MOUSE_UP, mouseUpHandler);
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.removeEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			stage.removeEventListener(Event.ENTER_FRAME, onFrameHandler);
		}
		
		private function setPoint(){
			LeftPoint.x = -(width / 2);
			LeftPoint.y = -(height / 2);
			RightPoint.x = (width / 2);
			RightPoint.y = -(height / 2);
			UpPoint.x = 0;
			UpPoint.y = -height;
			DownPoint.x = 0;
			DownPoint.y = 0;
		}
		
		private function onFrameHandler(event:Event){
			setPoint();
			
			if(up == true && !jumping){
				Yspeed = -JumpSpeed;
			}
			if(down == true){
				
			}
			if(right == true){
				Xspeed += Acceleration;
			}
			if(left == true){
				Xspeed -= Acceleration;
			}
			if(!up && !down && !right && !left){
				Xspeed *= Friction;
			}
			
			if(bubbled && bubble.MagicEnergy <= 0){
				bubbled = false;
				stage.removeChild(bubble);
				Main.world.realWorld.mask = new MovieClip();
			} else if(bubbled){
				bubble.MagicEnergy -= 0.08;
			} else if(bubble.MagicEnergy > bubble.Magic){
				bubble.MagicEnergy = bubble.Magic;
			} else {
				bubble.MagicEnergy += 0.25;
			}
			Main.magicBar.updateMagicEnergy();
			
			if(bubbled && bubble.Magic > 6){
				//HIT LEVEL LEFT
				if(Level.getObstaclesRealWorld().hitTestPoint(this.x + LeftPoint.x, this.y + LeftPoint.y, true)){
					if(Xspeed < 0){
						Xspeed *= -0.5;
					}
				}
				
				//HIT LEVEL RIGHT
				if(Level.getObstaclesRealWorld().hitTestPoint(this.x + RightPoint.x, this.y + RightPoint.y, true)){
				   if(Xspeed > 0){
						Xspeed *= -0.5;
					}
				}
				
				//HIT LEVEL UP
				if(Level.getObstaclesRealWorld().hitTestPoint(this.x + UpPoint.x, this.y + UpPoint.y, true)){
				   if(Yspeed < 0){
						Yspeed *= -0.5;
					}
				}
				
				//HIT LEVEL DOWN
				if(Level.getObstaclesRealWorld().hitTestPoint(this.x + DownPoint.x, this.y + DownPoint.y, true)){
				   if(Yspeed > 0){
						Yspeed = 0;
						jumping = false;
					}
				} else {
					jumping = true;
					Yspeed += Gravity;
				}
				
				for(var i:uint = 0; i < Level.getCrystalsAmountRealworld(); i++){
					if(this.hitTestObject(Level.getCrystalRealWorld(i))){
						bubble.addMagic(1); 
						Level.getCrystalsRealWorld().removeChild(Level.getCrystalRealWorld(i));
					}
				}
				
				if(Level.realWorld.Rat.hitTestPoint(this.x + DownPoint.x, this.y + DownPoint.y, true) && Xspeed > 1){
					Xspeed = 0;
					Level.realWorld.Rat.rotation += 3;
					Level.realWorld.WindmillArm.rotation += 3;
					Level.realWorld.Obstacles.hitbox.rotation += 3;
					Level.chaosWorld.Windmill. WindmillArm.rotation += 3;
					Level.chaosWorld.Obstacles.hitbox.rotation += 3;
				} else if(Level.realWorld.Rat.hitTestPoint(this.x + DownPoint.x, this.y + DownPoint.y, true) && Xspeed < -1){
					Xspeed = 0;
					Level.realWorld.Rat.rotation -= 3;
					Level.realWorld.WindmillArm.rotation -= 3;
					Level.realWorld.Obstacles.hitbox.rotation -= 3;
					Level.chaosWorld.Windmill. WindmillArm.rotation -= 3;
					Level.chaosWorld.Obstacles.hitbox.rotation -= 3;
				}
			} else{
				//HIT LEVEL LEFT
				if(Level.getObstaclesChaosWorld().hitTestPoint(this.x + LeftPoint.x, this.y + LeftPoint.y, true)){
					if(Xspeed < 0){
						Xspeed *= -0.5;
					}
				}
				
				//HIT LEVEL RIGHT
				if(Level.getObstaclesChaosWorld().hitTestPoint(this.x + RightPoint.x, this.y + RightPoint.y, true)){
				   if(Xspeed > 0){
						Xspeed *= -0.5;
					}
				}
				
				//HIT LEVEL UP
				if(Level.getObstaclesChaosWorld().hitTestPoint(this.x + UpPoint.x, this.y + UpPoint.y, true)){
				   if(Yspeed < 0){
						Yspeed *= -0.5;
					}
				}
				
				//HIT LEVEL DOWN
				if(Level.getObstaclesChaosWorld().hitTestPoint(this.x + DownPoint.x, this.y + DownPoint.y, true)){
				   if(Yspeed > 0){
						Yspeed = 0;
						jumping = false;
					}
				} else {
					jumping = true;
					Yspeed += Gravity;
				}
				
				for(var u:uint = 0; u < Level.getCrystalsAmountChaosWorld(); u++){
					if(this.hitTestObject(Level.getCrystalChaosWorld(u))){
						bubble.addMagic(1);
						Level.getCrystalsChaosWorld().removeChild(Level.getCrystalChaosWorld(u));
					}
				}
			}
			if(Xspeed > 0 && bubble.Magic >= bubble.MaxMagic){
				this.gotoAndStop("VictoryRight");
				
				if(VRight.currentFrame < 2){
					removeHandlers();
				} if(VRight.currentFrame >= 200){
					Level.realWorld.mask = null;
					Level.chaosWorld.mask = new MovieClip();
					Gravity = 0.8;
				} else {
					Gravity = 0;
				}
			} else if(Yspeed < -3 && Xspeed > 0){
				this.gotoAndStop("Jump Right");
			} else if(Yspeed >= -3 && Yspeed <= 2 && jumping && Xspeed > 0){
				this.gotoAndStop("JumpMid Right");
			} else if(Yspeed > 2 && jumping && Xspeed > 0){
				this.gotoAndStop("JumpDown Right");
			} else if(Xspeed > 1){
				this.gotoAndStop("Walk Right");
			} else if(Xspeed >= 0 && Xspeed <= 1){
				this.gotoAndStop("Stand Right");
			}
			
			if(Xspeed <= 0 && bubble.Magic >= bubble.MaxMagic){
				this.gotoAndStop("VictoryLeft");
				if(VLeft.currentFrame < 2){
					removeHandlers();
				} else if(VLeft.currentFrame >= 200){
					Level.realWorld.mask = null;
					Level.chaosWorld.mask = new MovieClip();
					Gravity = 0.8;
				} else {
					Gravity = 0;
				}
			} else if(Yspeed < -1 && Xspeed < 0){
				this.gotoAndStop("Jump Left");
			} else if(Yspeed > 1 && jumping && Xspeed < 0){
				this.gotoAndStop("JumpDown Left");
			} else if(Yspeed > -1 && Yspeed < 1 && jumping && Xspeed < 0){
				this.gotoAndStop("JumpMid Left");
			} else if(Xspeed < -1){
				this.gotoAndStop("Walk Left");
			} else if(Xspeed <= 0 && Xspeed >= -1){
				this.gotoAndStop("Stand Left");
			}
			
			if(Xspeed > MaxXspeed){
				Xspeed = MaxXspeed;
			} else if(Xspeed < MaxXspeed * -1){
				Xspeed = MaxXspeed * -1;
			}
			
			if(Yspeed > MaxYspeed){
				Yspeed = MaxYspeed;
			} else if(Yspeed < MaxYspeed * -1){
				Yspeed = MaxYspeed * -1;
			}
			
			Level.x -= Xspeed;
			Level.y -= Yspeed;
			
			Level.chaosWorld.Background1.x += Xspeed * 0.75;
			Level.chaosWorld.Background1.y += Yspeed * 0.75;
			Level.realWorld.Background1.x += Xspeed * 0.75;
			Level.realWorld.Background1.y += Yspeed * 0.75;
		}
		
		private function mouseDownHandler(event:MouseEvent){
			bubbled = true;
			stage.addChild(bubble);
			Main.world.realWorld.mask = this.bubble.Mask;
		}
		
		private function mouseUpHandler(event:MouseEvent){
			if(bubbled){
				bubbled = false;
				stage.removeChild(bubble);
				Main.world.realWorld.mask = new MovieClip();
			}
		}
		
		private function keyDownHandler(event:KeyboardEvent){
			if(event.keyCode == 87){
				up = true;
			}
			if(event.keyCode == 83){
				down = true;
			}
			if(event.keyCode == 68){
				right = true;
			}
			if(event.keyCode == 65){
				left = true;
			}
		}
		
		private function keyUpHandler(event:KeyboardEvent){
			if(event.keyCode == 87){
				up = false;
			}
			if(event.keyCode == 83){
				down = false
			}
			if(event.keyCode == 68){
				right = false;
			}
			if(event.keyCode == 65){
				left = false;
			}
		}
	}
	
}
